
/* Common Open Systems Environment, Common Graphics Environment	 */		
/* Extension to	PEX 5.1	version	2.  File date: February	10, 1994 */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN	MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD	TO THIS	      */
/*  SOFTWARE, INCLUDING	ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT	SHALL SUN MICROSYSTEMS,	INC. BE	LIABLE FOR ANY SPECIAL,	      */
/*  INDIRECT OR	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER	RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER	TORTIOUS ACTION, ARISING OUT OF	OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE	OF THIS	SOFTWARE.			      */
/*									      */
/******************************************************************************/


 /* =======================================================================
  * NOTE NOTE NOTE  Insert this	section
  *		    at the end of pl_escape.c file
  * ====================================================================='=
  */

/***** Start of	Ext section ************/

#include "PEXExtlib.h"
#include "PEXExtlibint.h"


int PEXExtQueryColorApprox(display, drawable, 
    color_approx, count_return,	color_approx_return, all_return) 
      
INPUT Display			*display;
INPUT Drawable			drawable;
INPUT PEXColorApproxEntry	*color_approx;
OUTPUT unsigned	long		*count_return;
OUTPUT PEXColorApproxEntry	**color_approx_return;
OUTPUT int			*all_return;

{
    char			*escapeData;
    int				escapeSize;
    char			*escapeOutData;
    unsigned long		escapeOutDataSize;
    pexExtQueryColorApproxData	*header;
    pexColorApproxEntry		*ptr;
    int				fpConvert;
    int				fpFormat;
    pexColorApproxEntry		*src;
    PEXColorApproxEntry		*dst;
    pexExtQueryColorApproxReplyData	*escapeOutHeader;
    pexSwitch			capxIsSupported;

    /*
     * Fill in the escape record.
     */

    escapeSize = SIZEOF	(pexExtQueryColorApproxData) +
	SIZEOF (pexColorApproxEntry);
    escapeData = PEXAllocBuf (escapeSize);

    fpFormat = PEXGetProtocolFloatFormat (display);
    fpConvert =	(fpFormat != NATIVE_FP_FORMAT);

    header = (pexExtQueryColorApproxData *) escapeData;
    header->fpFormat = fpFormat;
    header->drawable = drawable;

    ptr	= (pexColorApproxEntry *)
	  (escapeData +	SIZEOF (pexExtQueryColorApproxData));

    ptr->approxType = color_approx->type;
    ptr->approxModel = color_approx->model;
    ptr->max1 =	color_approx->max1;
    ptr->max2 =	color_approx->max2;
    ptr->max3 =	color_approx->max3;
    ptr->dither	= color_approx->dither;
    ptr->mult1 = color_approx->mult1;
    ptr->mult2 = color_approx->mult2;
    ptr->mult3 = color_approx->mult3;
    ptr->basePixel = color_approx->base_pixel;

    if (fpConvert)
    {
	FP_CONVERT_HTON	(color_approx->weight1,	ptr->weight1, fpFormat);
	FP_CONVERT_HTON	(color_approx->weight2,	ptr->weight2, fpFormat);
	FP_CONVERT_HTON	(color_approx->weight3,	ptr->weight3, fpFormat);
    }
	else
    {
	ptr->weight1 = color_approx->weight1;
	ptr->weight2 = color_approx->weight2;
	ptr->weight3 = color_approx->weight3;
    }

    /*
     * Generate	the escape.
     */

    escapeOutData = PEXEscapeWithReply(display,	
	PEXExtEscapeOpcodeQueryColorApprox,
	escapeSize, escapeData,	&escapeOutDataSize);

    PEXFreeBuf (escapeData);

    escapeOutHeader = (pexExtQueryColorApproxReplyData *) escapeOutData;
    capxIsSupported = escapeOutHeader->capxIsSupported;
    if (!capxIsSupported)
    {	
	/*
	 * Format the reply data to return to caller
	 */

	*all_return = escapeOutHeader->allCapxs;
	*count_return =	escapeOutHeader->count;

	*color_approx_return = dst = (PEXColorApproxEntry *)
	    PEXAllocBuf	(sizeof	(PEXColorApproxEntry) *	escapeOutHeader->count);

	src = (pexColorApproxEntry *)
	    (escapeOutData + SIZEOF (pexExtQueryColorApproxReplyData));

	EXTRACT_LISTOF_COLOR_APPROX (escapeOutHeader->count, src, dst, 
	   fpConvert, fpFormat)	
    }

    PEXFreeBuf (escapeOutData);

    return(capxIsSupported);
}


PEXExtTextureMap PEXExtCreateTM(display, domain, domain_data, texel_arrays)
      
INPUT Display			*display;
INPUT int			domain;
INPUT PEXExtTMDomainData	*domain_data;
INPUT PEXExtTexelArray		*texel_arrays;

{
    char			*escapeData;
    int				escapeSize;
    unsigned long		escapeOpcode; 
    pexExtCreateTMData		*req;
    pexExtCreateTMExtraDataData	*ereq;
    pexExtTexelDimension	*dim;
    int				fpConvert;
    int				fpFormat;
    char			*pBuf;
    char			*pList;
    unsigned short int		numLevels;
    PEXEnumTypeIndex		sdomain;
    PEXEnumTypeIndex		texelType;
    PEXExtTextureMap		tm;
    int				texelSize;
    int				clientTexelSize;
    pexSwitch			domainIsColor;
    pexSwitch			nextPieceIsDimension;
    unsigned long		listBytes;     /* bytes	remaining in list     */
					       /* of texel arrays	      */
    unsigned long		levelTexels;   /* texels remaining in current */
					       /* level	of texel arrays	      */
    unsigned long		reqBytes;      /* bytes	remaining in request  */
    unsigned short int		i;
    unsigned long		texelCount; 


    /*
     * Get a TM	resource id from X.
     */

    tm = XAllocID (display);

    /*
     * Determine the size of the escape	data (adjust for maximum
     * request size), then allocate a buffer.
     */

    sdomain = domain;

    domainIsColor = (sdomain ==	PEXExtTMDomainColor1D ||
		     sdomain ==	PEXExtTMDomainColor2D ||
		     sdomain ==	PEXExtTMDomainColor3D )	 ?
		    1 :	0 ;

    numLevels =	(domainIsColor)	? domain_data->data.color.num_levels : 0;

    escapeSize = SIZEOF	(pexExtCreateTMData);

    if (domainIsColor)			   
    {
       texelType       = domain_data->data.color.texel_type;
       texelSize       = GetTexelSize (texelType); 
       clientTexelSize = GetClientTexelSize (texelType); 

       GetTexelCount(sdomain, texel_arrays, 0, numLevels, texelCount);

       listBytes = ( numLevels * SIZEOF	(pexExtTexelDimension) ) +
		   ( texelCount	* texelSize ); 
    }
    else listBytes = 0;

    escapeSize += listBytes;

    reqBytes = ((XMaxRequestSize (display) >> 2) << 2) - SIZEOF	(pexEscapeReq);
    escapeSize = ( escapeSize <	reqBytes ) ? escapeSize	: reqBytes;

    escapeData = PEXAllocBuf (escapeSize);

    /*
     * Fill in the CreateTM header fields for any domains.
     */

    fpFormat = PEXGetProtocolFloatFormat (display);
    fpConvert =	(fpFormat != NATIVE_FP_FORMAT);

    req	= (pexExtCreateTMData *) escapeData;
    req->fpFormat   = fpFormat;
    req->numArrays  = numLevels;
    req->tmId	    = tm;	  
    req->domain	    = domain;	 
    req->listLength = listBytes;

    /*
     * Fill in the color domain	data.
     */
		  
    if (domainIsColor)			   
    {
       req->tmType	 = domain_data->data.color.tm_type;
       req->texelType	 = texelType;
       req->numMapLevels = numLevels;
    }

    /*
     * Fill in the list	of texel arrays, alternating dimensions	with
     * texel data.  Use	CreateTMExtraData for subsequent requests.	    
     */

    reqBytes =	escapeSize - SIZEOF (pexExtCreateTMData);
    pBuf =  ((char *) req) + SIZEOF (pexExtCreateTMData);

    escapeOpcode = PEXExtEscapeOpcodeCreateTM;

    nextPieceIsDimension = 1;
    i =	0; 
    while ( i <	numLevels )  
    {
      if ( (nextPieceIsDimension &&	   /* if next piece won't fit */
	      (reqBytes	< SIZEOF (pexExtTexelDimension))) ||
	   (!nextPieceIsDimension &&
	      (reqBytes	< texelSize)))
      {				    /* issue current escape request */
	PEXEscape (display, escapeOpcode, (pBuf	- escapeData), 
		   escapeData);
				    /* set up for next escape request */  
	ereq = (pexExtCreateTMExtraDataData *) escapeData;
	ereq->tmId	= tm;	      

	reqBytes =  escapeSize - SIZEOF	(pexExtCreateTMExtraDataData);
	pBuf =	((char *) ereq)	+ SIZEOF (pexExtCreateTMExtraDataData);
	escapeOpcode = PEXExtEscapeOpcodeCreateTMExtraData;
      }	 

      if (nextPieceIsDimension)		   /* next piece is dimension */
      {	 
	dim = (pexExtTexelDimension *) pBuf;
	dim->t0	= texel_arrays[i].dimension.t0;
	dim->t1	= texel_arrays[i].dimension.t1;
	dim->t2	= texel_arrays[i].dimension.t2;

	pBuf = ((char *) dim) +	SIZEOF (pexExtTexelDimension);
	reqBytes  -= SIZEOF (pexExtTexelDimension);
					      /* set up	for texels */
	pList =	(char *) texel_arrays[i].array.luminance;
	GetTexelCount(sdomain, texel_arrays, i,	(i+1), levelTexels);
	nextPieceIsDimension = 0;
      }

      else if (levelTexels > 0)		   /* next piece is texels */
      {
	texelCount = reqBytes /	texelSize;
	texelCount = (texelCount < levelTexels)	? texelCount : levelTexels;

	STORE_LISTOF_TEXEL_VAL (texelCount, texelType, pList, pBuf, 
				fpConvert, fpFormat);  

	levelTexels -= texelCount; 
	reqBytes    -= texelCount * texelSize; 
	pList	    += texelCount * clientTexelSize; 
      }

      if (levelTexels <= 0)	   /* if level completed, move to next one */
      {
	i++;		
	nextPieceIsDimension = 1;
      }
    }

    /*
     * Generate	the final escape.
     */

    PEXEscape (display,	escapeOpcode, (pBuf - escapeData), escapeData);

    PEXFreeBuf (escapeData);

    return (tm);
}



void PEXExtFreeTM (display, texture_map)	 
      
INPUT Display			*display;
INPUT PEXExtTextureMap		texture_map;

{
    char			*escapeData;
    int				escapeSize;
    pexExtFreeTMData		*req;

    /*
     * Fill in the escape record.
     */

    escapeSize = SIZEOF	(pexExtFreeTMData);
    escapeData = PEXAllocBuf (escapeSize);

    req	= (pexExtFreeTMData *) escapeData;
    req->tmId =	texture_map;

    /*
     * Generate	the escape.
     */

    PEXEscape(display, PEXExtEscapeOpcodeFreeTM, escapeSize, escapeData);

    PEXFreeBuf (escapeData);
}


PEXExtTMDescription PEXExtCreateTMDescription (display,	parameterization,
    param_data,	tm_rendering_order, count, tm_ids)		
      
INPUT Display			*display;
INPUT int			parameterization;
INPUT PEXExtTMParameterizationData	*param_data;
INPUT int			tm_rendering_order;
INPUT unsigned int		count;		 
INPUT PEXExtTextureMap		*tm_ids;      

{
    char			*escapeData;
    int				escapeSize;
    pexExtCreateTMDescriptionData		*req;
    int				fpConvert;
    int				fpFormat;
    char			*pBuf;
    char			*pList;
    PEXExtTMDescription		tmd;
    PEXEnumTypeIndex		param;

     /*
     * Get a TM	description resource id	from X.
     */

    tmd	= XAllocID (display);

    /*
     * Determine the size of the escape	record and allocate it.
     */

    param = parameterization;

    escapeSize = SIZEOF	(pexExtCreateTMDescriptionData)	+
		 (count	* SIZEOF (pexExtTextureMap));

    escapeSize += param	== (PEXEnumTypeIndex) PEXExtTMParamExplicit ? 0	:
		  ((param == (PEXEnumTypeIndex)	
			     PEXExtTMParamReflectSphereVRC ||
		    param == (PEXEnumTypeIndex)	
			     PEXExtTMParamReflectSphereWC ) ? 
		       SIZEOF (pexExtParmReflect) : 
		  (param == (PEXEnumTypeIndex) PEXExtTMParamLinearVRC ?	
		       SIZEOF (pexExtParmLinear) :
		  PADDED_BYTES (param_data->data.imp_dep.length)));

    escapeData = PEXAllocBuf (escapeSize);

    /*
     * Fill in the CreateTMDescriptionData fields (except param	length)
     */

    fpFormat = PEXGetProtocolFloatFormat (display);
    fpConvert =	(fpFormat != NATIVE_FP_FORMAT);

    req	= (pexExtCreateTMDescriptionData *) escapeData;
    req->fpFormat	  = fpFormat;
    req->paramMethod	  = parameterization;
    req->tmDescriptionId  = tmd;	 
    req->tmRenderingOrder = tm_rendering_order;
    req->numTMIds	  = count;     
    req->paramData.method = parameterization;		     

    /*
     * Fill in the parameterization data and its length.
     */

    pBuf = ((char *) req) + SIZEOF (pexExtCreateTMDescriptionData);

    switch(param)	 
    {
    case ((PEXEnumTypeIndex) PEXExtTMParamExplicit):  

	req->paramData.length =	0;		  
	break;

    case ((PEXEnumTypeIndex) PEXExtTMParamReflectSphereVRC):  
    case ((PEXEnumTypeIndex) PEXExtTMParamReflectSphereWC):   

	pList =	(char *) &param_data->data.reflection; 
	STORE_LISTOF_FLOAT32 (16, pList, pBuf, fpConvert, fpFormat); 
	req->paramData.length =	SIZEOF (pexExtParmReflect);
	break;

    case ((PEXEnumTypeIndex) PEXExtTMParamLinearVRC):			

	pList =	(char *) &param_data->data.linear; 
	STORE_LISTOF_FLOAT32 (8, pList,	pBuf, fpConvert, fpFormat); 
	req->paramData.length =	SIZEOF (pexExtParmLinear);
	break;

    default:

	COPY_AREA ((char *) param_data->data.imp_dep.imp_dep, pBuf, 
	param_data->data.imp_dep.length); 
	pBuf +=	PADDED_BYTES (param_data->data.imp_dep.length);	

	req->paramData.length =	param_data->data.imp_dep.length;
    }

    req->paramLength = SIZEOF (pexExtParamData)	+ req->paramData.length;    

    /*
     * Fill in the TM ids.		  
     */

    pList = (char *) tm_ids; 
    STORE_LISTOF_CARD32	(count,	pList, pBuf)

    /*
     * Generate	the escape.
     */

    PEXEscape(display, PEXExtEscapeOpcodeCreateTMDescription, 
	escapeSize, escapeData);

    PEXFreeBuf (escapeData);

    return (tmd);
}


void PEXExtFreeTMDescription (display, tm_description)	
      
INPUT Display			*display;
INPUT PEXExtTMDescription	tm_description;

{
    char			*escapeData;
    int				escapeSize;
    pexExtFreeTMDescriptionData	*req;

    /*
     * Fill in the escape record.
     */

    escapeSize = SIZEOF	(pexExtFreeTMDescriptionData);
    escapeData = PEXAllocBuf (escapeSize);

    req	= (pexExtFreeTMDescriptionData *) escapeData;
    req->tmDescriptionId = tm_description;

    /*
     * Generate	the escape.
     */

    PEXEscape(display, PEXExtEscapeOpcodeFreeTMDescription, escapeSize,	
	escapeData);

    PEXFreeBuf (escapeData);
}


void _PEXExtStoreListOfTexel (count, texelType,	texels,	bufPtr,	fpFormat)

INPUT int			count;
INPUT int			texelType;
INPUT char			*texels;
INPUT char			**bufPtr;
INPUT int			fpFormat;

{
    int		i;
    char	*data;
    char	*pBuf =	*bufPtr;
    char	*pBufStart;
    
    /* move texels for the cases where bcopy will not work: */
    /*	 1) float conversion or				    */	
    /*	 2) 64 bit client and texel is not even	double word.*/


    if (!(data = (char *) texels))
	return;

    pBufStart =	pBuf;

    switch (texelType)
    {
    case PEXExtTexelLuminanceFloat: 

	for (i = 0; i <	count; i++)
	{
	    PEXExtTexelLuminance *tex =	(PEXExtTexelLuminance *) data;
	    data += sizeof (PEXExtTexelLuminance);

	    FP_CONVERT_HTON_BUFF (tex->luminance, pBuf,	fpFormat);
	    pBuf += SIZEOF (float);
	}
	break;

    case PEXExtTexelLuminanceAlphaFloat: 

	for (i = 0; i <	count; i++)
	{
	    PEXExtTexelLuminanceAlpha *tex = (PEXExtTexelLuminanceAlpha	*) data;
	    data += sizeof (PEXExtTexelLuminanceAlpha);

	    FP_CONVERT_HTON_BUFF (tex->luminance, pBuf,	fpFormat);
	    pBuf += SIZEOF (float);
	    FP_CONVERT_HTON_BUFF (tex->alpha, pBuf, fpFormat);
	    pBuf += SIZEOF (float);
	}
	break;

    case PEXExtTexelRGBFloat: 

	for (i = 0; i <	count; i++)
	{
	    PEXExtTexelRGB *tex	= (PEXExtTexelRGB *) data;
	    data += sizeof (PEXExtTexelRGB);

	    FP_CONVERT_HTON_BUFF (tex->red, pBuf, fpFormat);
	    pBuf += SIZEOF (float);
	    FP_CONVERT_HTON_BUFF (tex->green, pBuf, fpFormat);
	    pBuf += SIZEOF (float);
	    FP_CONVERT_HTON_BUFF (tex->blue, pBuf, fpFormat);
	    pBuf += SIZEOF (float);
	}
	break;

    case PEXExtTexelRGBAlphaFloat: 

	for (i = 0; i <	count; i++)
	{
	    PEXExtTexelRGBAlpha	*tex = (PEXExtTexelRGBAlpha *) data;
	    data += sizeof (PEXExtTexelRGBAlpha);

	    FP_CONVERT_HTON_BUFF (tex->red, pBuf, fpFormat);
	    pBuf += SIZEOF (float);
	    FP_CONVERT_HTON_BUFF (tex->green, pBuf, fpFormat);
	    pBuf += SIZEOF (float);
	    FP_CONVERT_HTON_BUFF (tex->blue, pBuf, fpFormat);
	    pBuf += SIZEOF (float);
	    FP_CONVERT_HTON_BUFF (tex->alpha, pBuf, fpFormat);
	    pBuf += SIZEOF (float);
	}
	break;

    case PEXExtTexelLuminanceAlphaInt8:	

	for (i = 0; i <	count; i++)
	{
	    COPY_SMALL_AREA (data, pBuf, 2);
	    pBuf += 2;
	    data += sizeof (PEXExtTexelLuminanceAlpha8);
	}
	break;

    case PEXExtTexelLuminanceInt8: 
	
	for (i = 0; i <	count; i++)
	{
	    COPY_SMALL_AREA (data, pBuf, 1);
	    pBuf += 1;
	    data += sizeof (PEXExtTexelLuminance8);
	}
	break;

    case PEXExtTexelRGBAlphaInt8: 

	for (i = 0; i <	count; i++)
	{
	    COPY_SMALL_AREA (data, pBuf, 4);
	    pBuf += 4;
	    data += sizeof (PEXExtTexelRGBAlpha8);
	}
	break;

    case PEXExtTexelRGBInt8: 

	for (i = 0; i <	count; i++)
	{
	    COPY_SMALL_AREA (data, pBuf, 3);
	    pBuf += 3;
	    data += sizeof (PEXExtTexelRGB8);
	}
	break;

    case PEXExtTexelLuminanceAlphaInt16: 

	for (i = 0; i <	count; i++)
	{
	    PEXExtTexelLuminanceAlpha16	*tex = 
	       (PEXExtTexelLuminanceAlpha16 *) data;
	    data += sizeof (PEXExtTexelLuminanceAlpha16);

	    STORE_CARD16 (tex->luminance, pBuf);
	    STORE_CARD16 (tex->alpha, pBuf);
	}
	break;

    case PEXExtTexelLuminanceInt16: 

	for (i = 0; i <	count; i++)
	{
	    PEXExtTexelLuminance16 *tex	= (PEXExtTexelLuminance16 *) data;
	    data += sizeof (PEXExtTexelLuminance16);

	    STORE_CARD16 (tex->luminance, pBuf);
	}
	break;

    case PEXExtTexelRGBAlphaInt16: 

	for (i = 0; i <	count; i++)
	{
	    PEXExtTexelRGBAlpha16 *tex = (PEXExtTexelRGBAlpha16	*) data;
	    data += sizeof (PEXExtTexelRGBAlpha16);

	    STORE_CARD16 (tex->red, pBuf);
	    STORE_CARD16 (tex->green, pBuf);
	    STORE_CARD16 (tex->blue, pBuf);
	    STORE_CARD16 (tex->alpha, pBuf);
	}
	break;

    case PEXExtTexelRGBInt16: 

	for (i = 0; i <	count; i++)
	{
	    PEXExtTexelRGB16 *tex = (PEXExtTexelRGB16 *) data;
	    data += sizeof (PEXExtTexelRGB16);

	    STORE_CARD16 (tex->red, pBuf);
	    STORE_CARD16 (tex->green, pBuf);
	    STORE_CARD16 (tex->blue, pBuf);
	}
	break;
    }
   
    *bufPtr += PADDED_BYTES ((pBuf-pBufStart));
}
/***** End of Ext section ************/
