
/* Common Open Systems Environment, Common Graphics Environment  */		
/* Extension to PEX 5.1 version 2.  File date: April 14, 1994    */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS       */
/*  SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT SHALL SUN MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL,       */
/*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.                             */
/*									      */
/******************************************************************************/

 /* =======================================================================
  * NOTE NOTE NOTE  Insert this	section
  *		    at the end of pl_store.h file
  * ====================================================================='=
  */
/***** Start of	Ext section ************/

#define STORE_LISTOF_EXT_VERTEX(_count, _vertexSize, _colorType, _vertFPData, _vertexAttr, _vertexData, _pBuf, _fpConvert, _fpFormat) \
{ \
    if (_fpConvert) \
    { \
        _PEXExtStoreListOfVertex (_count, _colorType, \
	    _vertFPData, _vertexAttr, _vertexData, &(_pBuf), _fpFormat); \
    } \
    else \
    { \
	int bytes = _count * _vertexSize; \
        COPY_AREA ((char *) _vertexData.no_data, _pBuf, bytes); \
        _pBuf += bytes; \
    } \
}

#ifndef WORD64

#define STORE_LISTOF_TEXEL_VAL(_count, _texType, _pList, _pBuf, _fpConvert, _fpFormat) \
{ \
    if ((_fpConvert) &&  \
        (((_texType) == PEXExtTexelLuminanceFloat) ||  \
         ((_texType) == PEXExtTexelLuminanceAlphaFloat) ||  \
         ((_texType) == PEXExtTexelRGBFloat) ||  \
         ((_texType) == PEXExtTexelRGBAlphaFloat) )) \
    { \
        _PEXExtStoreListOfTexel (_count, _texType, _pList, &(_pBuf), _fpFormat); \
    } \
    else \
    { \
        int bytes = (_count) * GetTexelSize ((_texType)); \
        COPY_AREA ((char *) _pList, _pBuf, bytes); \
        _pBuf += PADDED_BYTES (bytes); \
    } \
}

#else /* WORD64 */

#define STORE_LISTOF_TEXEL_VAL(_count, _texType, _pList, _pBuf, _fpConvert, _fpFormat) \
{ \
    if ((!_fpConvert) &&  \
        (((_texType) == PEXExtTexelLuminanceAlphaFloat) ||  \
         ((_texType) == PEXExtTexelRGBAlphaFloat) )) \
    { \
        int bytes = (_count) * GetTexelSize ((_texType)); \
        COPY_AREA ((char *) _pList, _pBuf, bytes); \
        _pBuf += PADDED_BYTES (bytes); \
    } \
    else \
    { \
        _PEXExtStoreListOfTexel (_count, _texType, _pList, &(_pBuf), _fpFormat); \
    } \
}

#endif /* WORD64 */

/***** End of Ext section ************/

